useMB=0			; conditional assembly: set to 1 if you have the MasmBasic library
if useMB
	include D:\masm32\MasmBasic\MasmBasic.inc	; download from http://www.masm32.com/board/index.php?topic=12460
else
	include D:\masm32\include\masm32rt.inc
	.686
	.xmm
endif

include D:\masm32\macros\timers.asm	; from http://www.masm32.com/board/index.php?topic=770.0
uselib ShlWapi		; for StrStr

MyTestCode	PROTO: DWORD, :DWORD

.data
txString	db "This is a lnoong string, more than 100 chars, and at position #100 the pattern we are looking for: deniz", 0
txPattern1	db "deniz", 0
txPattern2	db "DeniZ", 0

.data?
str1 db 200 dup(?)
str2 db 200 dup(?)

.code
start:
  testversion = 0	; conditional assembly: set to 1 if you want to enter strings manually, 0 to take predefined strings
  if testversion
	print "Enter string to be searched:", 9
	invoke StdIn,ADDR str1,100
	print "Enter string to be found:", 9
	invoke StdIn,ADDR str2,100
	invoke MyTestCode, offset str1, offset str2
	.if eax
		print "yes", 13, 10
	.else
		print "no", 13, 10
	.endif
  else
	push 1
	call ShowCpu	; print brand string and SSE level
	; Get timings
	SleepMs =	50	; test if anything changes when changing this
	LOOP_COUNT =	100000	; One Mio would be a typical value
	REPEAT 2
		invoke Sleep, SleepMs
		counter_begin LOOP_COUNT, HIGH_PRIORITY_CLASS
				invoke MyTestCode, offset txString, offset txPattern1
		counter_end
		print str$(eax), 9, "cycles for MyTestCode (UoSunSetter)", 13, 10
		invoke Sleep, 100
		counter_begin LOOP_COUNT, HIGH_PRIORITY_CLASS
				invoke InString, 1, offset txString, offset txPattern1
				xchg eax, edi
		counter_end
		print str$(eax), 9, "cycles for InString, result="
		print str$(edi), 13, 10
		if useMB

			invoke Sleep, 100
			counter_begin LOOP_COUNT, HIGH_PRIORITY_CLASS
				mov edi, Instr_(offset txString, offset txPattern1)
			counter_end
			print str$(eax), 9, "cycles for Instr_ (MasmBasic), result="
			print str$(edi), 13, 10

			invoke Sleep, 100
			counter_begin LOOP_COUNT, HIGH_PRIORITY_CLASS
				mov edi, Instr_(offset txString, offset txPattern2, 1)
			counter_end
			print str$(eax), 9, "cycles for Instr_, case-insensitive, result="
			print str$(edi), 13, 10

			invoke Sleep, 100
			counter_begin LOOP_COUNT, HIGH_PRIORITY_CLASS
				mov edi, wInstr(wChr$("This is a lnoong string, more than 100 chars, and at position #100 the pattern we are looking for: deniz"), wChr$("deniz"))
			counter_end
			print str$(eax), 9, "cycles for wInstr, case-sensitive, result="
			print str$(edi), 13, 10

			invoke Sleep, 100
			counter_begin LOOP_COUNT, HIGH_PRIORITY_CLASS
				mov edi, wInstr(wChr$("This is a lnoong string, more than 100 chars, and at position #100 the pattern we are looking for: deniz"), wChr$("deniZ"), 1)
			counter_end
			print str$(eax), 9, "cycles for wInstr, case-insensitive, result="
			print str$(edi), 13, 10

		endif
		invoke Sleep, 100
		counter_begin LOOP_COUNT, HIGH_PRIORITY_CLASS
				invoke crt_strstr, offset txString, offset txPattern1
				xchg eax, edi
		counter_end
		print str$(eax), 9, "cycles for C strstr, result="
		sub edi, offset txString
		inc edi
		print str$(edi), 13, 10

		invoke Sleep, 100
		counter_begin LOOP_COUNT, HIGH_PRIORITY_CLASS
				invoke StrStr, offset txString, offset txPattern1
				xchg eax, edi
		counter_end
		print str$(eax), 9, "cycles for StrStr, result="
		sub edi, offset txString
		inc edi
		print str$(edi), 13, 10

		invoke Sleep, 100
		counter_begin LOOP_COUNT/10, HIGH_PRIORITY_CLASS
				invoke StrStrI, offset txString, offset txPattern2
				xchg eax, edi
		counter_end
		print str$(eax), 9, "cycles for StrStrI, result="
		sub edi, offset txString
		inc edi
		print str$(edi), 13, 10

		print chr$(13, 10)
	ENDM
	endif
	inkey chr$(13, 10, "--- ok ---", 13)
	invoke ExitProcess, 0

MyTestCode proc pString, pPattern

;Get the length of pString and save it to bl
	xor bl, bl ;Zero bl	
	lea esi, pString

repeatforpString: ;repeat until the end of pString
	mov al, [esi]
	inc esi
	inc bh
	cmp al, 0
	jne repeatforpString



;Get the length of pPattern and save it to bh
	xor bh, bh ;Zero bh	
	lea esi, pPattern

repeatforpPattern: ;repeat until the end of pPattern
	mov al, [esi]
	inc esi
	inc bh
	cmp al, 0
	jne repeatforpPattern
		
;Decrease bl and bh because there will be no need to compare '0'
	dec bl
	dec bh

;Set cl to know how many times to check(in my case bl will be always greater then bh)
	mov cl, bl
	sub cl, bh
	inc cl

;Set initials
	lea esi, pString
	lea edi, pPattern
	lea edx, pString ;will need a copy
	mov ch, bh; another copy for len of pPattern
	jmp MatchFirstLetters ;start by finding first match


PrepareForNextMatchingCheck:     ;Prepare registers for for finding next first letter match also test if it is the last check
	inc edx
	mov esi, edx
	dec cl
	cmp cl, 0
	je NotFound



MatchFirstLetters:
	mov al, [esi]
	mov ah, [edi]
	cmp al, ah
	jne PrepareForNextMatchingCheck ;no luck? try next
	
	lea edi, pPattern ;need to reset edi since it will manipulated by CompareTheRest
	inc edi	;first letter already checked so start from second one
	inc esi ;same as above
	mov bh, ch ;reset the iterator used in CompareTheRest


CompareTheRest:		;Match the rest of the chars one by one
	mov al, [esi]
	mov ah, [edi]
	cmp al, ah
	jne PrepareForNextMatchingCheck
	dec bh
	cmp bh, 1
	je Found ;if comparision is done pPattern's length-1 times and there is no mismatch then found
	inc esi
	inc edi
	jmp CompareTheRest




NotFound:
	mov eax, 0
	jmp finish
Found: 	
	mov eax, 1
	jmp finish

;wait for input and end

finish:
	ret
MyTestCode endp

ShowCpu proc	; mode:DWORD
COMMENT @ Usage: 
  push 0, call ShowCpu	; simple, no printing, just returns SSE level
  push 1, call ShowCpu	; prints the brand string and returns SSE level@
  pushad
  sub esp, 80	; create a buffer for the brand string
  mov edi, esp		; point edi to it
  xor ebp, ebp
  .Repeat
  	lea eax, [ebp+80000002h]
	db 0Fh, 0A2h	; cpuid 80000002h-80000004h
	stosd
	mov eax, ebx
	stosd
	mov eax, ecx
	stosd
	mov eax, edx
	stosd
	inc ebp
  .Until ebp>=3
  push 1
  pop eax
  db 0Fh, 0A2h		; cpuid 1
  xor ebx, ebx		; CpuSSE
  xor esi, esi		; add zero plus the carry flag
  bt edx, 25		; edx bit 25, SSE1
  adc ebx, esi
  bt edx, 26		; edx bit 26, SSE2
  adc ebx, esi
  bt ecx, esi		; ecx bit 0, SSE3
  adc ebx, esi
  bt ecx, 9			; ecx bit 9, SSE4
  adc ebx, esi
  dec dword ptr [esp+4+32+80]	; dec mode in stack
  .if Zero?
	mov edi, esp	; restore pointer to brand string
  	.Repeat				
		.Break .if byte ptr [edi]!=32	; mode was 1, so show a string but skip leading blanks
		inc edi
	.Until 0
	.if byte ptr [edi]<32
		print chr$("pre-P4")
	.else
		print edi	; CpuBrand
	.endif
	.if ebx
		print chr$(32, 40, "SSE")	; info on SSE level, 40=(
		print str$(ebx), 41, 13, 10	; 41=)
	.endif
  .endif
  add esp, 80		; discard brand buffer (after printing!)
  mov [esp+32-4], ebx	; move ebx into eax stack position - returns eax to main for further use
  ifdef MbBufferInit
	call MbBufferInit
  endif
  popad
  ret 4
ShowCpu endp
END start

OPT_Tmp2Asm	1
OPT_Res	0
